unit Box_Obj;
{$F+,O+,S-,D-}

interface

uses Dos, Objects, Views, App;

type    PBox = ^TBox;
                        TBox = object(TView)
                                constructor Init(var Bounds: TRect);
                                procedure       Draw;                                                                   virtual;
                                function                GetPalette: PPalette;   virtual;
                        end;

const CBox = CListViewer;

implementation
uses Drivers;
constructor TBox.Init(var Bounds: TRect);
begin
        TView.Init(Bounds);
        SetState(sfShadow, true);
end;

procedure TBox.Draw;
var B: TDrawBuffer;
                C: Byte;
                I: byte;
begin
        C := GetColor(1);
        MoveChar(B, ' ', C, Size.X);
        for i:=0 to Size.Y-1 do WriteLine(0, I, Size.X, 1, B);
        MoveChar(B,' ',C,Size.X);
        MoveChar(B,'',C,Size.X); WordRec(B[0]).Lo:=218; WordRec(B[Size.X-1]).Lo:=191; WriteLine(0, 0, Size.X, 1, B);
        MoveChar(B,'',C,Size.X); WordRec(B[0]).Lo:=192; WordRec(B[Size.X-1]).Lo:=217; WriteLine(0, Size.Y-1, Size.X, 1, B);
        MoveChar(B,' ',C,Size.Y-2);
        MoveChar(B,'',C,Size.Y-2); WriteLine(0, 1, 1, Size.Y-2, B); WriteLine(Size.X-1, 1, 1, Size.Y-2, B);
end;

function TBox.GetPalette;
const P: String[Length(CBox)] = CBox;
begin
        GetPalette := @P;
end;

end.

